	parameter (nrays=4932,npixels=1000)
	real x(npixels),d(nrays),v(npixels),w(npixels),
     *	matrix(nrays,npixels)
	open(3,file='congra.out',form='formatted',status='unknown')
c ---	read the parameters
	write(*,*) 'Number of rows (n1) and columns (n2) in the matrix ?'
	read(*,*) n1,n2
	nt=n1
	npix=n2
c ---	read the data
	call readdata(d,nt)
888	continue
	write(*,'(a)') ' number of iterations ? '
	read(*,*) itmax
	call pstomo(nt,npix,x,d,v,w,itmax,matrix)
	stop
	end


	subroutine readmatrix(a,m,n)
	real a(m,n)
	character*60 file
	write(*,'(a)') ' name of the file which contains the matrix'
	read(*,'(a60)') file
	open(4,file=file,form='unformatted',status='old')
	read(4) a
	write(*,*) 'matrix read'
	close(4)
	return
	end

	subroutine readdata(d,n)
	real d(n)
	character*60 filedata
	write(*,'(a)') 'name of the file which contains the data'
	read(*,'(a60)') filedata
	open(1,file=filedata,status='old')
	read(1,*) d
	close(1)
	return
	end

	subroutine pstomo(m,n,x,u,v,w,itmax,matrix)
	dimension x(n),u(m),v(n),w(n)
	real matrix(m,n)
c ---	read the matrix
	call readmatrix(matrix,m,n)
c ---	initialize
	do 10 i=1,n
	x(i)=0.
	v(i)=0.
10	continue
	call normlz(m,u,beta)
	b1=beta
	call atupv(m,n,u,v,matrix)
	call normlz(n,v,alfa)
	rhobar=alfa
	phibar=beta
	do 2 i=1,n
		w(i)=v(i)
2	continue
c ---	repeat
	do 3 iter=1,itmax
c ---	bidiagonalization
	   a=-alfa
	   do 4 i=1,m
		u(i)=a*u(i)
4	   continue
c
	   call avpu(m,n,u,v,matrix)
	   call normlz(m,u,beta)
	   b=-beta
	   do 5 i=1,n
		v(i)=b*v(i)
5	   continue
	   call atupv(m,n,u,v,matrix)
	   call normlz(n,v,alfa)
c --- 	modified qr
	   oneorho=1./sqrt(rhobar*rhobar+beta*beta)
c
	   c=rhobar*oneorho
	   s=beta*oneorho
	   teta=s*alfa
	   rhobar=-c*alfa
	   phi=c*phibar
	   phibar=s*phibar
	   t1=phi*oneorho
	   t2=-teta*oneorho
c ---	update
	   do 6 i=1,n
		x(i)=t1*w(i)+x(i)
		w(i)=t2*w(i)+v(i)
6	   continue
c
	   r=phibar/b1
c ---	intermediate output
3	continue
	write(*,*) iter,alfa,beta,r
	write(3,*) x
	return
	end

	subroutine normlz(n,x,s)
c ---	normalizes vector x
	dimension x(n)
	s=0.
	do 1 i=1,n
		s=s+x(i)*x(i)
1	continue
	s=sqrt(s)
	ss=1./s
	do 2 i=1,n
		x(i)=x(i)*ss
2	continue
	return
	end

	subroutine avpu(m,n,u,v,a)
c ---	computes u=u+a*v
	real u(m),v(n),a(m,n)
	do  i=1,m
		do j=1,n
		u(i)=u(i)+a(i,j)*v(j)
		enddo
	enddo
	return
	end

	subroutine atupv(m,n,u,v,a)
c ---	computes v=v+a(transpose)*u
	dimension u(m),v(n),a(m,n)
	do  j=1,n
		do i=1,m
		v(j)=v(j)+a(i,j)*u(i)
		enddo
	enddo
	return
	end
