c move source and receiver positions to a common plane. The new positions
c are at the same relative true-distances and at the same depths. This
c is how I correct for deviation. Writes files in the proper format
c for ray tracing.
	character*80 file
c  In files
	write(*,*)  'Input file?'
	read(*,'(a80)') file
	open(9,file=file,
     * 	form='formatted',status='old')

c  Out file
c real traveltimes
	open(unit=2,file='/scr/reinaldo/straight.times',
     *	status='unknown') 
	open(unit=4,file='/scr/reinaldo/only-receivers.out',
     *	status='unknown')
	open(unit=8,file='/scr/reinaldo/only-sources.out',
     *	status='unknown')
	open(unit=30,file='ntimes',status='unknown')
	write(*,*) ' Output files:'
c x and z positions of the receivers (after correcting for deviation)
c	write(*,*) ' /work/reinaldo/data/only-receivers.out'
c z positions of the sources
c	write(*,*) ' /work/reinaldo/data/only-sources.out'
c	write(*,*) ' /work/reinaldo/data/straight.times'

	call deviation
	stop
	end

	subroutine deviation
	parameter (nmaxray=40000) 
	real zshot(nmaxray),zgeo(nmaxray),xshot(nmaxray),xgeo(nmaxray),
     *	yshot(nmaxray), ygeo(nmaxray),time(nmaxray),newx(nmaxray),
     *	zshots(nmaxray),newxs(nmaxray),times(nmaxray)
        dimension istartshot(nmaxray),istartgeo(nmaxray)
	common/pi/pio180

	pio4=acos(-1.)*0.25

	zshift=0.

        n=1
c this is the format for Hastings
1       read(9,*,end=999) ish,irn,time(n),xshot(n),yshot(n),
     *  zshot(n),swlz,xgeo(n),ygeo(n),zgeo(n),rwlz
	if(time(n).eq.0.) goto 1
c correct depths
		zgeo(n)=zgeo(n)-zshift
		zshot(n)=zshot(n)-zshift
        n=n+1
        goto 1
999     nt=n-1
	write(*,*) nt,' traveltimes read'
	
        do i=1,nt 
                xx=(xshot(i)-xgeo(i))*(xshot(i)-xgeo(i))
                yy=(yshot(i)-ygeo(i))*(yshot(i)-ygeo(i))
                newx(i)=sqrt(xx+yy)
c		write(*,*) abs(zshot(i)-zgeo(i))
        enddo
		
	call minmax(nt,newx,axmax,axmin)

	write(*,*) 'maximum horizontal separation ',axmax
	write(*,*) 'minimum horizontal separation ',axmin

	call minmax(nt,zgeo,zgeomax,zgeomin)
	call minmax(nt,zshot,zshotmax,zshotmin)

	write(*,*) 'Min shot depth = ',zshotmin,' Max shot depth = ',
     *zshotmax
	write(*,*) 'Min rec depth = ',zgeomin,' Max rec depth = ',
     *zgeomax

	do i=1,nt
		newx(i)=axmax-newx(i)
	enddo

c common receiver gather
        ig=1
	istartgeo(ig)=0
	ig=ig+1
        do j=1,n-1
        if(zgeo(j).ne.zgeo(j+1)) then
	istartgeo(ig)=j
	ig=ig+1
	endif
	enddo	
	istartgeo(ig)=n
	igt=ig
	write(4,*) igt-2

	it=1
	do ig=1,igt-2
		m=1
		do k=istartgeo(ig)+1,istartgeo(ig+1)
		ratio=(abs(zshot(k)-zgeo(istartgeo(ig)+1))/axmax)
		angle= atan(ratio)*180./acos(-1.)
c select the desired ray angles
c	write(*,*) angle
		if(angle.gt.0.and.angle.lt.90.) then
			zshots(m)=zshot(k)
			newxs(m)=newx(k)
			times(m)=time(k)
			m=m+1
			it=it+1
		else
			nt=nt-1
		endif
		enddo
	call write_all(zgeo(istartgeo(ig)+1),ig,m-1,zshots,
     *	newx(istartgeo(ig)+1),times)
	enddo
	call rewrite_times(times,it-1)
	return
	end

	subroutine write_all(zshot,ig,m,zgeos,newx,times)
	real zgeos(m),newx,times(m)
	common/pi/pio180
	write(2,*) times
	write(4,*) newx,zshot
	write(8,*) ig,m
	write(8,*) zgeos,times
	return
	end

	subroutine write_positions(zshot,zgeo,newx,time,nt)
	real zshot(nt),zgeo(nt),newx(nt),time(nt)
	write(4,*) zshot,zgeo,newx,time
	return
	end
	
        subroutine minmax(n,arr,camax,camin)
        real arr(n)
        camax=arr(1)
        do i=2,n
        camax=amax1(camax,arr(i))
        enddo
        camin=arr(1)
        do i=2,n
        camin=amin1(camin,arr(i))
        enddo
        return
        end

	subroutine rewrite_times(times,nt)
	real times(nt)
	write(*,*) nt,' traveltimes written'
	write(30,*) nt
	rewind 2
	read(2,*) times
	rewind 2
	write(2,*) times
	return
	end
